# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2010 Nexedi SA and Contributors. All Rights Reserved.
# Copyright (c) 2006-2008 Zope Corporation and Contributors.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#
##############################################################################

from hexagonit.recipe.cmmi import Recipe as OriginalRecipe
import subprocess
import logging

class Recipe(OriginalRecipe):
  def _getArchitecture(self):
    return subprocess.Popen(['uname', '-m'], stdout=subprocess.PIPE,
        stderr=subprocess.STDOUT).communicate()[0].strip()

  def install(self):
    arch = self._getArchitecture()
    log = logging.getLogger(self.name)
    if arch not in ['i386', 'i586', 'i686']:
      # no patching needed
      log.debug('No patching needed on %r architecture' % arch)
      return OriginalRecipe.install(self)
    if 'CFLAGS' in self.environ or 'CXXFLAGS' in self.environ:
      self.environ['CFLAGS'] += ' -march=i686'
      self.environ['CXXFLAGS'] += ' -march=i686'
    else:
      self.environ['CFLAGS'] = '-march=i686'
      self.environ['CXXFLAGS'] = '-march=i686'
    log.info(
      'Patched CFLAGS and CXXFLAGS on 32bit arch to being able to compile')

    return OriginalRecipe.install(self)
